
/**************************************************************************
**  (c) Copyright 2003, Andromeda Technology & Automation
** This is free software; you can redistribute it and/or modify it under the
** terms of the GNU General Public License, see the file COPYING.
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : rpm_filter.h
**      SYSTEM NAME    : 
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      :  
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Nov 27, 2003
**      LAST UPDATE     : Nov 27, 2003
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: rpm_filter.h,v $
   Revision 1.1  2003/12/04 10:38:09  arjen
   Major redesign. All input is handled through XML. Raw input data is first
   transformed into an XML document for further processing.
   A collection of polymorphic classes handle the transformation of various
   input formats into XML.
   Classifying input data is done with a finite improbability calculation.

*****************************/

/* static const char *RCSID = "$Id: rpm_filter.h,v 1.1 2003/12/04 10:38:09 arjen Exp $"; */

#include "message_filter.h"
#include "line_cooker.h"

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : rpm_filter
//  BASECLASS      : 
//  MEMBERS        :
//  OPERATORS      :
//  METHODS        : 
//
//  DESCRIPTION    : 
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Nov 27, 2003
///////////////////////////////////////////////////////////////////////////
*/

class rpm_filter : public message_filter
{

protected:

public:

   rpm_filter(String host, UTC arriv, String service) : message_filter(host, arriv, service)
   {
   }

   virtual void construct_XML(message_buffer &in, std::strstream &xml);
};

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : rpm_cooker
//  BASECLASS      : 
//  MEMBERS        :
//  OPERATORS      :
//  METHODS        : 
//
//  DESCRIPTION    : 
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Nov 27, 2003
///////////////////////////////////////////////////////////////////////////
*/

class rpm_cooker : public line_cooker
{

protected:


public:

   rpm_cooker()
   {
   }

   bool check_pattern(String logline);
   bool cook_this(String logline, UTC arrival);

   String message_type()
   {
      return "package list";
   }

};
