
/**************************************************************************
**  (c) Copyright 2003, Andromeda Technology & Automation
** This is free software; you can redistribute it and/or modify it under the
** terms of the GNU General Public License, see the file COPYING.
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : xml_cooker.h
**      SYSTEM NAME    : 
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      :  The XML cooker does not cook anything. It is here to
**                      match the XML header.
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Nov 26, 2003
**      LAST UPDATE     : Nov 26, 2003
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: xml_cooker.h,v $
   Revision 1.1  2003/12/04 10:38:09  arjen
   Major redesign. All input is handled through XML. Raw input data is first
   transformed into an XML document for further processing.
   A collection of polymorphic classes handle the transformation of various
   input formats into XML.
   Classifying input data is done with a finite improbability calculation.

*****************************/

/* static const char *RCSID = "$Id: xml_cooker.h,v 1.1 2003/12/04 10:38:09 arjen Exp $"; */

#include "line_cooker.h"

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : xml_cooker
//  BASECLASS      : line_cooker
//  MEMBERS        :
//  OPERATORS      :
//  METHODS        : 
//
//  DESCRIPTION    : 
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Nov 26, 2003
///////////////////////////////////////////////////////////////////////////
*/

class xml_cooker : public line_cooker
{

   bool XML_detected;

public:

   xml_cooker()
   {
      XML_detected = false;
   }

   bool check_pattern(String logline);
   bool cook_this(String logline, UTC arrival);

   String message_type()
   {
      return "XML";
   }

};
