<?php

/**********************************************************************************
**  (c) Copyright 2002, Brenno J.S.A.A.F. de Winter, De Winter Information Soltions
** This is free software; you can redistribute it and/or modify it under the
** terms of the GNU General Public License, see the file COPYING.
***********************************************************************************/


   function db_select ($inp_dbms) {
   /* This function delivers some robustness to several names that can be used
    * for the same database. Multiple names are interpreted as a standard name.
    * If no valid name has been entered a warning will be given.
    * Input-values: 
    *   - $inp_dbms: name for the DBMS
    * Output-values:
    *   - NONE
    */
     $local_db_input = strtolower(trim($inp_dbms));      
     switch ($local_db_input) {
        case "postgres":
	  $local_db_type = "postgres";
	  break;
	case "postgresql":
	  $local_db_type = "postgres";
	  break;
	case "psql":
	  $local_db_type = "postgres";
	  break;
	case "pgsql":
	  $local_db_type = "postgres";
	  break;
	default:
	  syslog(LOG_WARN, "Invalid DBMS read from config-file");
          $local_db_type = "xxxxx";
	  break;
      }
      if ($local_db_type <> "xxxxx") {
	require_once ("db.".$local_db_type.".php");
      }

   function copy_db_class ($inp_class, $connection_string) {
   /* This function takes a database class, sets the values for the connection,
    * opens the connection and returns the new cloned class
    * INPUT	: inp_class   - Typically a database class
    * OUTPUT    : Class       - with cloned database.
    */

    $new_class = new db();
    $new_class->db_host     = $inp_class->db_host;
    $new_class->db_name     = $inp_class->db_name;
    $new_class->db_user     = $inp_class->db_user;
    $new_class->db_password = $inp_class->db_password;
    $new_class->db_connect($connection_string);
    return $new_class;

   }
      
   }
?>
