<?php 

/**************************************************************************
**  (c) Copyright 2003, Andromeda Technology & Automation
** This is free software; you can redistribute it and/or modify it under the
** terms of the GNU General Public License, see the file COPYING.
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : parameter_compare.php
**      SYSTEM NAME    : Gnucomo - Gnu Computer Monitoring
**      VERSION NUMBER : $Revision: 1.6 $
**
**  DESCRIPTION      : 
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Dec 04, 2002
**      LAST UPDATE     : Dec 03, 2003
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: parameter_compare.php,v $
   Revision 1.6  2003/12/03 08:03:28  arjen
   Optionally show or hide removed parameters from the parameter
   comparison page.

   Revision 1.5  2003/08/14 10:31:57  arjen
   BUGFIX: Removed parameters were somtimes shown on the wrong side
   of the parameter difference page.

   Revision 1.4  2003/07/15 11:06:45  arjen
   Removed parameters are displayed in a shaded style.

   Revision 1.3  2003/02/13 09:01:29  arjen
   All web interface pages use the page class.

   Revision 1.2  2003/02/05 09:47:39  arjen
   Display the difference of all package class parameters for two objects

******************************/

// RCSID = "$Id: parameter_compare.php,v 1.6 2003/12/03 08:03:28 arjen Exp $";

ini_set('include_path', '.:./classes:../phpclasses');

require_once('page.class.php');


/*  Returns an associative array with all properties of a parameter (pid) */

function param_properties($db, $pid)
{
   $properties = NULL;
   $r = pg_exec($db, "SELECT name, value FROM property WHERE paramid='" . $pid . "'");
   for ($p = 0; $p < pg_numrows($r); $p++)
   {
      $prop = pg_fetch_object($r, $p);
      $properties[$prop->name] = $prop->value;
   }
   return $properties;
}

/*  Return true if both associative arrays are identical */

function property_compare($prop, $comp)
{
   $equal = true;

   if (empty($prop) || empty($comp))
   {
      $equal = empty($prop) && empty($comp);
   }
   else
   {
      reset($comp);
      foreach ($prop as $name => $val)
      {
         if ($equal)
         {
            $to_compare = each($comp);
            $equal = $to_compare[0] == $name && $to_compare[1] == $val;
         }
      }
   }
   return $equal;
}

/*   Display a parameter in two adjecent table cells  */

function display_parameter($name, $properties, $css_class = "", $shaded = FALSE)
{
   if ($shaded)
   {
      $css_class = 'shaded';
   }
   echo "<td";
   if ($css_class != "")
   {
      echo " class='$css_class'";
   }
   echo ">";
   echo $name;
   echo "</td><td";
   if ($css_class != "")
   {
      echo " class='$css_class'";
   }
   echo ">";
   foreach ($properties as $p_name => $p_value)
   {
      echo " $p_name=$p_value";
   }
   echo "</td>";
}

class param_diff extends page
{

   function is_removed($paramid)
   {
      $qry ="select change_nature from history where paramid= CAST('";
      $qry .= $paramid . "' AS BIGINT) order by modified desc";
      $rhist = pg_exec($this->database, $qry);
      $hist = pg_fetch_object($rhist, 0);

      return $hist->change_nature == "REMOVED";
   }

   function Body()
   {
   if (!empty($_POST['oid']))
   {
      $res = pg_exec($this->database, "SELECT objectid, objectname FROM object
                                       WHERE objectid=" . $_POST['oid']);
      $obj = pg_fetch_object($res, 0);
      echo "<h1>" . $_POST['class'] . " parameters for " . $obj->objectname;
      $res = pg_exec($this->database, "SELECT objectid, objectname FROM object
                                       WHERE objectid=" . $_POST['compare_to']);
      $cmp_obj = pg_fetch_object($res, 0);
      echo " compared to " . $cmp_obj->objectname . "</h1><hr>";

      $res = pg_exec($this->database, "SELECT objectid, paramid, name FROM parameter "
                     . "WHERE objectid=" . $obj->objectid . " OR objectid=" . $cmp_obj->objectid
                     . " AND class='" . $_POST['class'] . "' ORDER BY name, objectid");
      
      echo "<table>\n";
      echo "<tr><th colspan='2'>" . $obj->objectname . "</th>";
      echo "<th colspan='2'>" . $cmp_obj->objectname . "</th></tr>\n";
      echo "<tr><th>Name</th><th>Properties</th><th>Name</th><th>Propterties</th></tr>\n";

      $hide_removed = true;
      $hide_removed = $_POST['show_removed'] != 'on';

      $row = 0;
      while ($row < pg_numrows($res))
      {
         //   Find the next two parameters, optionally skipping removed parameters.

         $par = false;
         while (!$par && $row < pg_numrows($res))
         {
            $par = pg_fetch_object($res, $row);
            if ($hide_removed && $this->is_removed($par->paramid))
            {
               $par = false;
               $row++;
            }
         }
         $nextpar = false;
         $nextrow = $row + 1;
         while (!$nextpar && $nextrow < pg_numrows($res))
         {
            $nextpar = pg_fetch_object($res, $nextrow);
            if ($hide_removed && $this->is_removed($nextpar->paramid))
            {
               $nextpar = false;
               $nextrow++;
            }
         }
         echo "<tr>";

         if ($nextpar && $par->name == $nextpar->name)
         {
            /*  Both objects have this parameter */
            $row++;

            $pr = param_properties($this->database, $par->paramid);
            $prnext = param_properties($this->database, $nextpar->paramid);
            if (property_compare($pr, $prnext))
            {
               $Style = "";
            }
            else
            {
               $Style = "both";
            }
            // We want the parameters of $obj on the left, so we need
            // to swap the left and right sides if appropriate.

            if ($par->objectid == $obj->objectid)
            {
               display_parameter($par->name, $pr, $Style, $this->is_removed($par->paramid));
               display_parameter($nextpar->name, $prnext, $Style, $this->is_removed($nextpar->paramid));
            }
            else
            {
               display_parameter($nextpar->name, $prnext, $Style, $this->is_removed($nextpar->paramid));
               display_parameter($par->name, $pr, $Style, $this->is_removed($par->paramid));
            }
 
         }
         else
         {
            /*  Only one of the objects has this parameter */

            $pr = param_properties($this->database, $par->paramid);

            if ($par->objectid == $obj->objectid)
            {
               /*  Parameter belongs to the object on the left */

               display_parameter($par->name, $pr, "left", $this->is_removed($par->paramid));
               echo "<td>&nbsp;</td><td>&nbsp;";
            }
            else
            {
               /*  Parameter belongs to the object on the right */

               echo "<td>";
               echo "&nbsp;</td><td>&nbsp;</td>";
               display_parameter($par->name, $pr, "right", $this->is_removed($par->paramid));
            }
         }
         echo "</tr>\n";
         $row++;
      }
      echo "</table>\n";
   }
   }
}

$page = new param_diff("Gnucomo Parameter Comparison");

$page->Showpage();

?>
